




--// TSLibrary_Types.e
--// Tone koda <tone.skoda@siol.net>
--// Created on 6. October 2001.
--// This file contains global Euphoria types.





constant false = 0, true = 1





--/*
-- UNIQUE_STRICT [Created on 6. October 2001, 17:00]
-- The 'UNIQUE_STRICT' type is sequence which has members which are all different.
--
-- PARAMETERS
-- 's'
--    sequence.
--*/
global type UNIQUE_STRICT (sequence s)
    --// Current member, we're comparing each other member with this one.
    object cur_member

    --// Loop every member of 's', every time change 'cur_member'.
    for i = 1 to length (s) do
        cur_member = s [i]
        for j = 1 to length (s) do --// Loop every member of 's' again to compare ti against 'cur_member'.
            if i != j and equal (cur_member, s [j]) = true then --// Error: two member are equal.
                return false
            end if
        end for
    end for

    return true
end type

--/*
-- UNIQUE [Created on 6. October 2001, 17:00]
-- The 'UNIQUE' type is sequence which has members which are all different,
-- except if they are 0 or "" or {}.
--
-- PARAMETERS
-- 's'
--    sequence.
--*/
global type UNIQUE (sequence s)
    --// Current member, we're comparing each other member with this one.
    object cur_member

    --// Loop every member of 's', every time change 'cur_member'.
    for i = 1 to length (s) do
        cur_member = s [i]
        if equal (cur_member, {}) = false and equal (cur_member, 0) = false then --// Not 0 or {}.
            --// Loop every member of 's' again to compare it against 'cur_member'.
            for j = 1 to length (s) do
                if i != j then --// Not to compare member to itself.                
                        if equal (cur_member, s [j]) = true then --// Error: two members are equal.
                            return false
                        end if
                end if
            end for
        end if
    end for

    return true
end type

--/*
-- bool [Created on 6. October 2001, 17:10]
-- The 'bool' type: type should be 'false' or 'true'.
--
-- PARAMETERS
-- 'i'
--    integer.
--*/
global type bool (integer i)
    if i = true then
        return true
    end if
    if i = false then
        return true
    end if
    return false
end type

--/*
-- STRING [Created on 6. October 2001, 17:13]
-- The 'STRING' type: every member should be a letter (integer in range 0-255).
--
-- PARAMETERS
-- 's'
--    sequence.
--*/
global type STRING (sequence s)
    --// Loop every member of 's'.
    for i = 1 to length (s) do
        if s [i] < 0 or s [i] > 255 then --// Out of range.
            return false
        end if
    end for
    return true
end type