-- tk_types.e
-- Last Changed on 13/04/2001 at 14:25:35 by Derek Parnell

-----------------------------------------------------------------------------
--/topic Types
--/info
-- These are some useful data types

-----------------------------------------------------------------------------
-- Generic Tools
-- These are routines that I use often enough to wish they were part of
-- the standard Euphoria library

-----------------------------------------------------------------------------
--/topic Types
--/type int( i )
--/desc Same as the declaration integer().
--/ret True if /i i is an integer

global type int( integer i )
    return 1
end type

-----------------------------------------------------------------------------
--/topic Types
--/type seq( s )
--/desc Same as the declaration sequence().
--/ret True if /i s is a sequence.

global type seq( sequence s )
    return 1
end type

-----------------------------------------------------------------------------
--/topic Types
--/type string( s )
--/desc Must be a sequence containing integers between 0 and 255
--/ret True if /i s is a string.

global type string( object s )
    if not sequence(s) then
        return 0
    end if

    for i = 1 to length(s) do
        if not integer(s[i]) then
            return 0
        end if
        if s[i] < 0 or s[i] > 255 then
            return 0
        end if
    end for

    return 1
end type


